"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
const BaseInteractionManager_1 = require("../../InteractionsAPI/Managers/BaseInteractionManager");
class CommandInteractionManager extends BaseInteractionManager_1.default {
    constructor(client) {
        super(discord_js_1.CommandInteraction);
        this.client = client;
        this.client = client;
    }
    getInteractionId(interaction) {
        return interaction.commandName;
    }
    callInteraction(interaction) {
        var _a;
        (_a = this.getInteractionHandler(interaction)) === null || _a === void 0 ? void 0 : _a.run(interaction);
    }
    refreshCommands(guildId) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const data = [];
            this.interactionHandlers.forEach((handler) => {
                data.push(handler.commandOptions);
            });
            if (guildId) {
                const guild = yield this.client.guilds.fetch(guildId);
                if (!guild)
                    return;
                yield guild.commands.set(data);
            }
            else {
                yield ((_a = this.client.application) === null || _a === void 0 ? void 0 : _a.commands.set(data));
            }
        });
    }
}
exports.default = CommandInteractionManager;
