"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class InteractionEventHandler {
    constructor() {
        this.managers = new Map();
    }
    hook(client) {
        client.addListener('interactionCreate', (i) => this._handleInteraction(i));
    }
    use(handlers) {
        const h = Array.isArray(handlers) ? handlers : [handlers];
        for (const manager of h) {
            this.managers.set(manager._interactionCtor, manager);
        }
    }
    _handleInteraction(interaction) {
        this.managers.forEach((v, k) => {
            // note to self: we can also use ctor.isPrototypeOf to check for inherited inheritance (but not selfreference)
            if (Object.getPrototypeOf(interaction).constructor === k) {
                v.onInteraction(interaction);
            }
        });
    }
}
exports.default = InteractionEventHandler;
